%global gtk3_version 3.19.8
%global glib_version 2.53.2
%global gobject_introspection_version 1.41.0
%global gsettings_desktop_schemas_version 3.21.4
%global json_glib_version 0.12.0
%global libinput_version 1.4
%global pipewire_version 0.2.2

Name:           mutter328
Version:        3.28.3
Release:        5%{?dist}
Summary:        Window and compositing manager based on Clutter
License:        GPLv2+

URL:            http://www.gnome.org
Source0:        http://download.gnome.org/sources/mutter/3.28/mutter-%{version}.tar.xz

# These patches are all from the latest mutter package for fedora 28.
# The patch-set has been regenerated using git and git format-patch.

Patch0:         0000-gtk-shell-Work-around-non-working-startup-notificati.patch
Patch1:         0001-backends-cursor-upload-hw-cursor-on-demand.patch
Patch2:         0002-renderer-native-Check-calculated-transform-when-crea.patch
Patch3:         0003-backends-screen-cast-support-libpipewire-0.2.patch
Patch4:         0004-window-wayland-Always-update-monitor-for-non-user-op.patch
Patch5:         0005-window-Pass-flag-to-meta_window_update_monitor-inste.patch
Patch6:         0006-window-Force-update-monitor-on-hot-plugs.patch
Patch7:         0007-window-wayland-Don-t-recursive-indefinitely-when-upd.patch
Patch8:         0008-wayland-Nullify-monitor-resources-when-updating-outp.patch
Patch9:         0009-wayland-No-xdg-output-events-without-a-logical-monit.patch
Patch10:        0010-wayland-Clean-up-xwayland-grabs-even-if-surface-is-g.patch
Patch11:        0011-native-gpu-Handle-drmModeSetCrtc-failing-gracefully.patch
Patch12:        0012-window-Don-t-refuse-to-move-focus-to-the-grab-window.patch
Patch13:        0013-window-Explicitly-exclude-unmanaging-window-from-foc.patch
Patch14:        0014-tests-Add-closed-transient-test.patch
Patch15:        0015-monitor-Use-current-monitor-mode-to-check-whether-ac.patch
Patch16:        0016-gpu-kms-Don-t-crash-if-drmModeGetResources-returns-N.patch
Patch17:        0017-gpu-kms-Handle-drmModeGetResources-failing.patch
Patch18:        0018-monitor-manager-kms-Check-if-GPUs-can-have-outputs.patch
Patch19:        0019-renderer-native-Fallback-to-non-planar-API-if-gbm_bo.patch
Patch20:        0020-wayland-keyboard-Create-a-separate-keymap-shm-file-p.patch
Patch21:        0021-window-Return-1-if-meta_window_get_monitor-is-called.patch
Patch22:        0022-backends-x11-Only-free-cursor-if-it-was-created-succ.patch
Patch23:        0023-idle-monitor-Don-t-try-to-auto-start-SessionManager.patch
Patch24:        0024-window-unmanage-dialog-when-clearing-transient_for.patch
Patch25:        0025-wayland-xdg-shell-Queue-frame-callbacks-on-new-actor.patch
Patch26:        0026-wayland-surface-Add-API-to-cache-frame-callbacks.patch
Patch27:        0027-wayland-xdg-shell-Cache-pending-frame-callbacks-on-p.patch
Patch28:        0028-wayland-xdg-shell-Cache-frame-callbacks-if-toplevel-.patch
Patch29:        0029-wayland-xdg-shell-Handle-requests-after-toplevel-was.patch
Patch30:        0030-wayland-legacy-xdg-shell-Cache-frame-callbacks-if-to.patch
Patch31:        0031-wayland-legacy-xdg-shell-Handle-requests-after-tople.patch
Patch32:        0032-wayland-gtk-shell-Handle-requests-after-toplevel-was.patch

BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  desktop-file-utils
BuildRequires:  gnome-common
BuildRequires:  gtk-doc
BuildRequires:  libtool
BuildRequires:  zenity

BuildRequires:  gettext-devel
BuildRequires:  pam-devel

BuildRequires:  pkgconfig(cairo) >= 1.10.0
BuildRequires:  pkgconfig(egl)
BuildRequires:  pkgconfig(gbm)
BuildRequires:  pkgconfig(gl)
BuildRequires:  pkgconfig(glesv2)
BuildRequires:  pkgconfig(gio-unix-2.0) >= %{glib_version}
BuildRequires:  pkgconfig(glib-2.0) >= %{glib_version}
BuildRequires:  pkgconfig(gnome-desktop-3.0)
BuildRequires:  pkgconfig(gobject-introspection-1.0) >= %{gobject_introspection_version}
BuildRequires:  pkgconfig(gsettings-desktop-schemas) >= %{gsettings_desktop_schemas_version}
BuildRequires:  pkgconfig(gtk+-3.0) >= %{gtk3_version}
BuildRequires:  pkgconfig(gudev-1.0)
BuildRequires:  pkgconfig(json-glib-1.0) >= %{json_glib_version}
BuildRequires:  pkgconfig(libcanberra)
BuildRequires:  pkgconfig(libdrm)
BuildRequires:  pkgconfig(libinput)
BuildRequires:  pkgconfig(libpipewire-0.2) >= %{pipewire_version}
BuildRequires:  pkgconfig(libstartup-notification-1.0)
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(libwacom)
BuildRequires:  pkgconfig(pango) >= 1.2.0
BuildRequires:  pkgconfig(pangoft2)
BuildRequires:  pkgconfig(sm)
BuildRequires:  pkgconfig(systemd)
BuildRequires:  pkgconfig(upower-glib) >= 0.99.0
BuildRequires:  pkgconfig(wayland-server)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(xcb)
BuildRequires:  pkgconfig(xcomposite) >= 0.2
BuildRequires:  pkgconfig(xcursor)
BuildRequires:  pkgconfig(xdamage)
BuildRequires:  pkgconfig(xext)
BuildRequires:  pkgconfig(xfixes)
BuildRequires:  pkgconfig(xi) >= 1.6.0
BuildRequires:  pkgconfig(xkbcommon) >= 0.4.3
BuildRequires:  pkgconfig(xkbcommon-x11)
BuildRequires:  pkgconfig(xkbfile)
BuildRequires:  pkgconfig(xkeyboard-config)
BuildRequires:  pkgconfig(xrandr)
BuildRequires:  pkgconfig(xrender)
BuildRequires:  pkgconfig(xtst)

Obsoletes:      mutter-wayland < 3.13.0
Obsoletes:      mutter-wayland-devel < 3.13.0

# Make sure yum updates gnome-shell as well; otherwise we might end up with
# broken gnome-shell installations due to mutter ABI changes.
Conflicts:      gnome-shell < 3.21.1

# Conflict with the main mutter package
Conflicts:      mutter >= 3.29.4

Requires:       control-center-filesystem
Requires:       dbus-x11
Requires:       gsettings-desktop-schemas%{?_isa} >= %{gsettings_desktop_schemas_version}
Requires:       gtk3%{?_isa} >= %{gtk3_version}
Requires:       pipewire%{?_isa} >= %{pipewire_version}
Requires:       startup-notification
Requires:       zenity

Requires:       json-glib%{?_isa} >= %{json_glib_version}
Requires:       libinput%{?_isa} >= %{libinput_version}
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}

%description
Mutter is a window and compositing manager that displays and manages
your desktop via OpenGL. Mutter combines a sophisticated display engine
using the Clutter toolkit with solid window-management logic inherited
from the Metacity window manager.

While Mutter can be used stand-alone, it is primarily intended to be
used as the display core of a larger system such as GNOME Shell. For
this reason, Mutter is very extensible via plugins, which are used both
to add fancy visual effects and to rework the window management
behaviors to meet the needs of the environment.


%package        libs
Summary:        Shared libraries for %{name}

Requires:       mutter%{?_isa} >= 3.29.4
Conflicts:      mutter%{?_isa} < 3.29.4

%description    libs
Shared libraries for Mutter.


%package        devel
Summary:        Development package for %{name}

Requires:       %{name}-libs%{?_isa} = %{version}-%{release}
Conflicts:      mutter-devel%{?_isa}

%description    devel
Header files and libraries for developing Mutter plugins. Also includes
utilities for testing Metacity/Mutter themes.


%package        tests
Summary:        Tests for the %{name} package

Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}
Conflicts:      mutter-tests%{?_isa}

%description tests
The %{name}-tests package contains tests that can be used to verify
the functionality of the installed %{name} package.


%prep
%autosetup -n mutter-%{version} -p1


%build
autoreconf -f -i

%configure \
    --disable-static \
    --enable-compile-warnings=maximum \
    --enable-remote-desktop \
    --enable-installed-tests \
    --with-libwacom

%make_build


%install
%make_install

%find_lang mutter

# remove libtool archives
find %{buildroot} -name "*.la" -print -delete


%check
desktop-file-validate \
    %{buildroot}/%{_datadir}/applications/mutter.desktop


%ldconfig_scriptlets libs


%files -f mutter.lang
%{_bindir}/mutter

%{_libexecdir}/mutter-restart-helper

%{_libdir}/mutter/plugins/

%{_datadir}/applications/*.desktop
%{_datadir}/GConf/gsettings/mutter-schemas.convert
%{_datadir}/glib-2.0/schemas/org.gnome.mutter.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gnome.mutter.wayland.gschema.xml
%{_datadir}/gnome-control-center/keybindings/50-mutter-*.xml

%{_mandir}/man1/mutter.1*

%files libs
%license COPYING
%doc NEWS

%{_libdir}/lib*.so.*
%{_libdir}/mutter/

%exclude %{_libdir}/mutter/plugins

%files devel
%{_includedir}/*
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*

%files tests
%{_libexecdir}/installed-tests/mutter
%{_libexecdir}/installed-tests/mutter-clutter
%{_libexecdir}/installed-tests/mutter-cogl

%{_datadir}/installed-tests/mutter
%{_datadir}/installed-tests/mutter-clutter
%{_datadir}/installed-tests/mutter-cogl
%{_datadir}/mutter/tests


%changelog
* Wed Oct 17 2018 Fabio Valentini <decathorpe@gmail.com> - 3.28.3-5
- Forward-port patchset from current mutter on fedora 28.

* Sun Sep 09 2018 Fabio Valentini <decathorpe@gmail.com> - 3.28.3-4
- Initial compat package of mutter 3.28.

